DCMTK: SiAlgorithm Class Reference

DCMTK Version 3.6.9 OFFIS DICOM Toolkit

Loading...
Searching...
No Matches
Public Member Functions | List of all members
SiAlgorithm Class Referenceabstract

pure virtual base class of the public key crypto systems used for signature creation and verification. More...

Inheritance diagram for SiAlgorithm:

## Public Member Functions
| SiAlgorithm ()
| default constructor
virtual | ~SiAlgorithm ()
| destructor
virtual OFCondition | sign (const unsigned char *inputHash, unsigned long inputHashSize, E_MACType inputHashAlgorithm, unsigned char *outputSignature, unsigned long &outputSignatureSize)=0
| creates a signature.
virtual OFCondition | verify (const unsigned char *inputHash, unsigned long inputHashSize, E_MACType inputHashAlgorithm, const unsigned char *inputSignature, unsigned long inputSignatureSize, OFBool &verified)=0
| verifies a signature.
virtual unsigned long | getSize () const =0
| returns the size of a block of encrypted/decrypted ciphertext in bytes.
virtual E_KeyType | keyType () const =0
| returns the type of public key algorithm computed by this object

## Detailed Description

pure virtual base class of the public key crypto systems used for signature creation and verification.

All public key algorithm classes should inherit from this class. Instances of derived classes contain a single private or public key.

Remarks
  this class is only available if DCMTK is compiled with OpenSSL support enabled.

## Member Function Documentation

## ◆ getSize()

virtual unsigned long SiAlgorithm::getSize | ( |  | ) | const
| pure virtual

returns the size of a block of encrypted/decrypted ciphertext in bytes.

The result depends on the public key algorithm, key size and padding scheme. In general the input to decrypt() or encrypt() must be less than or equal to this block size. The output of decrypt() or encrypt() is always equal to this block size.

Returns
  block size for this public key cryptosystem and key

Implemented in SiPKEY.

## ◆ keyType()

virtual E_KeyType SiAlgorithm::keyType | ( |  | ) | const
| pure virtual

returns the type of public key algorithm computed by this object

Returns
  type of public key algorithm

Implemented in SiPKEY.

## ◆ sign()

virtual OFCondition SiAlgorithm::sign | ( | const unsigned char * | inputHash,
|  | unsigned long | inputHashSize,
|  | E_MACType | inputHashAlgorithm,
|  | unsigned char * | outputSignature,
|  | unsigned long & | outputSignatureSize )
| pure virtual

creates a signature.

Parameters

  inputHash | array of hash key bytes that are to be signed
  inputHashSize | length of hash key array in bytes
  inputHashAlgorithm | MAC algorithm used for creation of hash key. Required for creation of PKCS#1 RSA signature padding.
  outputSignature | pointer to array of at least getSize() which must be allocated by caller.
  outputSignatureSize | returns the number of bytes written to outputSignature.

Returns
  SI_EC_Normal if successful, errorcode otherwise.

Implemented in SiPKEY.

## ◆ verify()

virtual OFCondition SiAlgorithm::verify | ( | const unsigned char * | inputHash,
|  | unsigned long | inputHashSize,
|  | E_MACType | inputHashAlgorithm,
|  | const unsigned char * | inputSignature,
|  | unsigned long | inputSignatureSize,
|  | OFBool & | verified )
| pure virtual

verifies a signature.

Parameters

  inputHash | array of bytes containing hash key to be verified against signature
  inputHashSize | length of hash key array in bytes
  inputHashAlgorithm | MAC algorithm used for creation of hash key. Required for creation of PKCS#1 RSA signature padding.
  inputSignature | array of bytes containing signature to be verified
  inputSignatureSize | length of signature array in bytes
  verified | returns whether the signature was successfully verified

Returns
  SI_EC_Normal if successful, errorcode otherwise.

Implemented in SiPKEY.

The documentation for this class was generated from the following file:

- dcmsign/include/dcmtk/dcmsign/sialgo.h

Generated on Sat Mar 1 2025 for DCMTK Version 3.6.9 by Doxygen 1.13.2